local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Sackville")
local sep = "\001"

local options = {
    path = L["Equipment"] .. sep .. L["Set"],
    controls = {
        {
            ["inputType"] = "EditBox",
            ["label"] = GEARSETS_POPUP_TEXT,
            ["maxLetters"] = 16,
            ["paramName"] = "setName"
        }
    }
}

function CompareSet(item, params)
    if params.setName then
        local itemArray = GetEquipmentSetItemIDs(params.setName)
        if itemArray then
            for i=1, 19 do
                if itemArray[i] and itemArray[i] == item.id then
                    return true
                end
            end
        end
    end
    return false
end

Sackville.Filter:AddFilter(options.path, CompareSet, options)