local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Sackville")
local B = LibStub("LibBabble-Inventory-3.0")
local BL = B:GetLookupTable()

local itemQualities = {
    [ITEM_QUALITY0_DESC] = 0,
    [ITEM_QUALITY1_DESC] = 1,
    [ITEM_QUALITY2_DESC] = 2,
    [ITEM_QUALITY3_DESC] = 3,
    [ITEM_QUALITY4_DESC] = 4,
    [ITEM_QUALITY5_DESC] = 5,
    [ITEM_QUALITY6_DESC] = 6,
    [ITEM_QUALITY7_DESC] = 7
}

local function MakeQualityFilter(quality)
    local code = "return function (item) " .. string.format(      
        [[return item.quality == %d end]], quality)
    return assert(loadstring(code)())
end

local function IsArmor(item)
    return item.type == BL["Armor"]
end

local function IsShirt(item)
    return item.equipLoc == "INVTYPE_BODY"
end

local function IsTrinket(item)
    return item.equipLoc == "INVTYPE_TRINKET"
end

local function IsNecklace(item)
    return (item.equipLoc == "INVTYPE_NECK")
end

local function IsRing(item)
    return (item.equipLoc == "INVTYPE_FINGER")
end

local function IsTabard(item)
    return item.equipLoc == "INVTYPE_TABARD"
end

local function IsEquipment(item)
    if item.equipLoc == "" then
        return false
    else
        return true
    end
end

local sep = "\001"
Sackville.Filter:AddFilter(L["Equipment"], IsEquipment)
Sackville.Filter:AddFilter(L["Equipment"] .. sep .. BL["Trinket"], IsTrinket)
Sackville.Filter:AddFilter(L["Equipment"] .. sep .. BL["Shirt"], IsShirt)
Sackville.Filter:AddFilter(L["Equipment"] .. sep .. BL["Neck"], IsNecklace)
Sackville.Filter:AddFilter(L["Equipment"] .. sep .. BL["Ring"], IsRing)
Sackville.Filter:AddFilter(L["Equipment"] .. sep .. BL["Tabard"], IsTabard)

for name, value in pairs(itemQualities) do
    -- TODO: Localize "Quality"
    Sackville.Filter:AddFilter(QUALITY .. sep .. name, MakeQualityFilter(value))
end
