local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Sackville")

local sep = "\001"

local options_name = {
    path = HELPFRAME_ITEM_TITLE .. sep .. NAME,
    controls = {
        {
            ["inputType"] = "Dropdown",
            ["label"] = L["Operator"],
            ["values"] = { 
                L["Matches"],
                L["Begins with"],
                L["Contains"], 
                L["Ends with"]
            },
            ["paramName"] = L["Operator"]
        },
        {
            ["inputType"] = "EditBox",
            ["label"] = NAME,
            ["paramName"] = NAME
        }
    }
}


local options_ID = {
    path = HELPFRAME_ITEM_TITLE .. sep .. ID,
    controls = {
        {
            ["inputType"] = "EditBox",
            ["label"] = ID,
            ["paramName"] = ID
        }
    }
}

function string.starts(String,Start)
   return string.sub(String,1,string.len(Start))==Start
end

function string.ends(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end

function CompareName(item, params)
    Sackville:Debug(3, "filter", "CompareName: %s=%s, %s=%s",
        L["Operator"], tostring(params[L["Operator"]]), NAME, tostring(params[NAME]))
    if params and params[L["Operator"]] and params[NAME] then
        if params[L["Operator"]] == L["Matches"] then
            return item.name == params[NAME]
        elseif params[L["Operator"]] == L["Begins with"] then
            return string.starts(item.name, params[NAME])
        elseif params[L["Operator"]] == L["Contains"] then
            return string.find(item.name, params[NAME])
        elseif params[L["Operator"]] == L["Ends with"] then
            return string.ends(item.name, params[NAME])
        else
            return false -- This shouldn't happen
        end
    else
        -- Incomplete params
        return false
    end
end

function CompareID(item, params)
    Sackville:Debug(3, "filter", "CompareID: %s =? %s",
        item.id, tostring(params[ID]))
    if params and params[ID] then
        Sackville:Debug(3, "filter", "-- %s", 
            tostring(item.id == tonumber(params[ID])))
        return item.id == tonumber(params[ID])
    else
        Sackville:Debug(3, "filter", "-- FALSE (incomplete params)")
        -- Incomplete params
        return false
    end
end

Sackville.Filter:AddFilter(options_name.path, CompareName, options_name)
Sackville.Filter:AddFilter(options_ID.path, CompareID, options_ID)