local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville")
Sackville.Util = {}

function Sackville.Util.TableHasValues(t)
    if next(t) == nil then
        return false
    else
        return true
    end
end

function Sackville.Util.GetTableCount(t)
    local i = 0
    for _,_ in pairs(t) do
        i = i + 1
    end
    return i
end

function Sackville.Util.MakeMultiSorter(sortCriteria)
-- Returns a comparison function that can be used with table.sort()
-- sortCriteria is a table with key-value pairs where key is a valid name of an
-- element in an item object and value is either '<' or '>', which controls
-- whether or not we should sort by ascending or descending values.
	local code = "return function(a,b) if false then\n"

    for index=1, #sortCriteria do
        local key = sortCriteria[index].key
        local comparison = sortCriteria[index].comparison
        assert(key and comparison)
		code = code .. string.format("elseif a.%s ~= b.%s then return a.%s %s b.%s\n", key, key, key, comparison, key)
	end
    code = code .. " end end"
	
	return assert(loadstring(code)())
end

function Sackville.Util.kpairs(t, sortCriteria)
    local a = {}
    for _, item in pairs(t) do table.insert(a, item) end
    table.sort(a, Sackville.Util.MakeMultiSorter(sortCriteria))
    local i = 0      -- iterator variable
    local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return i, a[i]
        end
    end
    return iter
end

function Sackville.Util.DeepCopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end
